----------------------------------------------------------------------------------
-- POLYTECHNIQUE MONTREAL
-- ELE3311 - Systemes logiques programmables 
-- 
-- Module Name:    decod_1p4 
-- Description:    Decodeur 1 parmi 4 avec enable
--
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with signed or unsigned values
use IEEE.numeric_std.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity decod_1p4 is
port (
  clk_i                 : in    std_logic;
  rst_i                 : in    std_logic;  -- synchrone
  en_i                  : in    std_logic;  -- enable
  addr_i                : in    std_logic_vector(1 downto 0);
  decod_o               : out   std_logic_vector(3 downto 0)
);
end decod_1p4;


architecture behavioral of decod_1p4 is

  signal clk                  : std_logic;

  signal decod_f              : std_logic_vector(3 downto 0);
  signal decod_p              : std_logic_vector(3 downto 0);

begin
  clk <= clk_i;

  REGISTERED: process(clk)
  begin
    -- *** A completer ***
    if(rising_edge(clk)) then
        decod_p <= decod_f;
    end if;
  end process;


  COMBINATORIAL: process(addr_i, rst_i, en_i)
  begin
    -- *** A completer ***
    if(en_i = '1' and rst_i = '0') then
        case addr_i is
            when "00" =>
                decod_f <= "0001";
            when "01" =>
                decod_f <= "0010";
            when "10" =>
                decod_f <= "0100";
            when others =>
                decod_f <= "1000";
        end case;
    else
        decod_f <= "0000";
    end if;
  end process;


  -- Assign outputs
  -- *** A completer ***
  decod_o <= decod_p;

end behavioral;
